package service.example.page2;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.HashMap;

import framework.service.BasePortalService;

import framework.service.ServiceParameter;

public class Page2Service extends BasePortalService {

	public static final String SUCCESS = "/jsp/page2.jsp";
	public static final String ERROR   = "/jsp/page1.jsp";
	
	public String execute(ServiceParameter param){

		// ̓f[^擾
		Page2Form form = (Page2Form)param.getFormData();
		
		// [UID擾
		String id = form.getId();

		// [Uf[^Ǎ
		if ("1".equals(id)) {
			form.setName("");
			form.setType("1");
		} else if ("2".equals(id)){
			form.setName("");
			form.setType("2");
		} else if ("3".equals(id)){
			form.setName("");
			form.setType("3");
		} else {
			param.addError("[U폜ꂽAo^Ă܂B");
			return ERROR;
		}
		
		// [UʗpR{{bNXf[^
		ArrayList typeList = getTypeList();
//		form.setTypeList(typeList);
		form.setSessionObject("typeList", typeList);
		
		return SUCCESS;
		
	}
	
	private ArrayList getTypeList(){

		ArrayList typeList = new ArrayList();
		HashMap userType1 = new HashMap();
		userType1.put("type", "1");
		userType1.put("typeName" , "VXeǗ");
		typeList.add(userType1);
		HashMap userType2 = new HashMap();
		userType2.put("type", "2");
		userType2.put("typeName" , "ʎЈ");
		typeList.add(userType2);
		HashMap userType3 = new HashMap();
		userType3.put("type", "3");
		userType3.put("typeName" , "_Ј");
		typeList.add(userType3);

		return typeList;
	}
}
