package service.example.page3;

import framework.service.BasePortalService;
import framework.service.ServiceParameter;

public class Page3Service extends BasePortalService {

	public static final String SUCCESS = "/jsp/page3.jsp";
	public static final String ERROR   = "/jsp/page2.jsp";
	
	public String execute(ServiceParameter param){

		// ̓f[^`FbN
		if (!checkData(param)){
			return ERROR;
		} 

		// f[^XV
		param.addInfo("XV܂");
		
		return SUCCESS;
	}

	private boolean checkData(ServiceParameter param){

		// ̓f[^擾
		Page3Form form = (Page3Form)param.getFormData();

		// [UID`FbN
		String id   = form.getId();
		if ((id==null)||("".equals(id))) {
			param.addError("id", "[UID͂ĉ");
		} else if (id.length()>10){
			param.addError("id", "[UID͔p10ȓœ͂ĉ");
		}

		// [U`FbN
		String name = form.getName();
		if ((name==null)||("".equals(name))) {
			param.addError("name", "[U͂ĉ");
		} else if (name.length()>20){
			param.addError("name", "[U10ȓœ͂ĉ");
		}

		return (param.getErrorList().size()==0) ? true : false;
	}
}
