package service.example.serialize;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import org.apache.tools.zip.ZipEntry;
import org.apache.tools.zip.ZipOutputStream;

public class SerializeTest {

	public static void main(String[] args){
		
		SerializeTest prc = new SerializeTest();
		prc.execute();
	}
	
	public void execute(){
		
		ArrayList list = getTypeList();
		
//		serializeTest1(list);
//		serializeTest2();
//		serializeTest3();
		serializeTest4(list);
	}
	
	private void serializeTest2(){
		String a = "";
		System.out.println(a);
		
		byte[] b = a.getBytes();
		System.out.println(b);
		
		String c = new String(b);
		System.out.println(c);
	}

	private void serializeTest3(){
		
		byte[] a = new byte[2];
		a[0] = 0x31;
		a[1] = 0x31;
		System.out.println(a);
		
		String b = new String(a,0,2);
		System.out.println(b);

		byte[] c = b.getBytes();
		System.out.println(c);

		String d = new String(c,0,2);
		System.out.println(d);
	
	}

	private void serializeTest1(ArrayList typeList){

		String serStr = null;
		byte[] serBytes = null;
		try {
	        ByteArrayOutputStream bout = new ByteArrayOutputStream();
	        ObjectOutputStream out = new ObjectOutputStream(bout);
	        out.writeObject(typeList);
	        out.close();
	        serBytes = bout.toByteArray();
	        serStr = bout.toString();
//	        serStr = bout.toString("MS932");
//	        serStr = new String(serBytes,"MS932");
//	        serStr = new String(serBytes,0,serBytes.length);
		} catch (Exception e){
		}
		
		Object newObject = null;
		byte[] newBytes = null;
		try {
//			newBytes = serStr.getBytes();
			newBytes = serStr.getBytes("MS932");
//			newBytes = serStr.getBytes("Shift_JIS");
//			newBytes = serStr.getBytes("EUC_JP");
//			newBytes = serStr.getBytes("Windows-31J");
//			newBytes = serStr.getBytes("Windows-31j");
//			newBytes = serBytes;
	        ObjectInputStream in = new ObjectInputStream(new ByteArrayInputStream(newBytes));
	        newObject = in.readObject();
	        in.close();
		} catch (Exception e){
		}
		
		
		System.out.println("-- ̓e --");
		for (int i = 0; i < typeList.size(); i++) {
			HashMap rec = (HashMap)typeList.get(i);
			System.out.println(rec.get("type") + "=" + rec.get("typeName"));
		}

        System.out.println("-- VACY --");
        System.out.println(serBytes);
//        System.out.println(serStr);

		System.out.println("-- fVACY --");
        System.out.println(newBytes);
        if (newObject!=null){
			ArrayList list = (ArrayList)newObject;
			for (int i = 0; i < list.size(); i++) {
				HashMap rec = (HashMap)list.get(i);
				System.out.println(rec.get("type") + "=" + rec.get("typeName"));
			}
		}
	}

	private void serializeTest4(ArrayList typeList){

		System.out.println("-- ̓e --");
		for (int i = 0; i < typeList.size(); i++) {
			HashMap rec = (HashMap)typeList.get(i);
			System.out.println(rec.get("type") + "=" + rec.get("typeName"));
		}

		// VACY
		String serializeStr = StringSerializer.serialize(typeList);
		System.out.println("-- VACY --");
		System.out.println(serializeStr);

		String decryprStr = null;
		try {
			byte[] cryptByte = StringSerializer.encrypt("key", serializeStr);
			String cryprStr = new String(cryptByte, "MS932");
			System.out.println("-- Í --");
			System.out.println(cryprStr);

			decryprStr = StringSerializer.decrypt("key", cryprStr.getBytes("MS932"));
			System.out.println("--  --");
			System.out.println(decryprStr);
		
		} catch (Exception e){}

/*		
		ZipEntry target = new ZipEntry(serializeStr);
//		target.setCompressedSize(8);
		target.setSize(8);
		System.out.println(target.toString());
		target = null;
*/
		// fVACY
		Object obj = null;
		ArrayList list = null;
//		obj = StringSerializer.deserialize(serializeStr);
		obj = StringSerializer.deserialize(decryprStr);
		list = (ArrayList)obj;

		System.out.println("-- fVACY̓e --");
		for (int i = 0; i < list.size(); i++) {
			HashMap rec = (HashMap)list.get(i);
			System.out.println(rec.get("type") + "=" + rec.get("typeName"));
		}

	}

	private ArrayList getTypeList(){

		ArrayList typeList = new ArrayList();
		HashMap userType1 = new HashMap();
		userType1.put("type", "1");
		userType1.put("typeName" , "VXeǗ");
		typeList.add(userType1);
		HashMap userType2 = new HashMap();
		userType2.put("type", "2");
		userType2.put("typeName" , "ʎЈ");
		typeList.add(userType2);
		HashMap userType3 = new HashMap();
		userType3.put("type", "3");
		userType3.put("typeName" , "_Ј");
		typeList.add(userType3);

		return typeList;
	}
}
