package framework.service;

import java.sql.Connection;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import framework.form.BaseForm;

public class ServiceParameter {

	private HttpServletRequest  request;
	private HttpServletResponse response;
	private Connection dbCon;
	private BaseForm formData;
	private ArrayList errorList = new ArrayList();
	private ArrayList infoList  = new ArrayList();

	public HttpServletRequest getRequest() {
		return request;
	}
	public void setRequest(HttpServletRequest request) {
		this.request = request;
	}
	public HttpServletResponse getResponse() {
		return response;
	}
	public void setResponse(HttpServletResponse response) {
		this.response = response;
	}
	public Connection getDbCon() {
		return dbCon;
	}
	public void setDbCon(Connection dbCon) {
		this.dbCon = dbCon;
	}
	public BaseForm getFormData() {
		return formData;
	}
	public void setFormData(BaseForm formData) {
		this.formData = formData;
	}
	public void addError(String msg){
		ServiceMessage msgObj = new ServiceMessage();
		msgObj.setMsg(msg);
		errorList.add(msgObj);
	}
	public void addError(String key, String msg){
		ServiceMessage msgObj = new ServiceMessage();
		msgObj.setKey(key);
		msgObj.setMsg(msg);
		errorList.add(msgObj);
	}
	public void addInfo(String msg){
		ServiceMessage msgObj = new ServiceMessage();
		msgObj.setMsg(msg);
		infoList.add(msgObj);
	}
	public void addInfo(String key, String msg){
		ServiceMessage msgObj = new ServiceMessage();
		msgObj.setKey(key);
		msgObj.setMsg(msg);
		infoList.add(msgObj);
	}
	public ArrayList getErrorList(){
		return this.errorList;
	}
	public ArrayList getInfoList(){
		return this.infoList;
	}
}
