package service.example.serialize;

import java.io.*;

/**
 * 䕶܂܂Ȃɂ钼񉻁iVACYjsB
 * 
 * 񉻏ASCIÎ䕶łȂ(0x20`0x7E)
 * \镶ɕϊA܂͂̋tsB
 * 䕶1oCgƂɁAoCgl16i\L
 * <code>[</code><code>]</code>ň͂4oCgɕϊB
 */
public final class StringSerializer {

    private static final char S = '[';
    private static final char E = ']';

    /**
     * 񉻂B
     * @param object 񉻂IuWFNg
     * @return 񉻂ꂽ
     */
    public static String serialize(Object object) {
        ByteArrayOutputStream byteArray = new ByteArrayOutputStream();
        try {
            ObjectOutputStream os = new ObjectOutputStream(byteArray);
            try {
                os.writeObject(object);
            } finally {
                os.close();
            }
        } catch (IOException ex) {
            throw new RuntimeException(ex.toString());
        }
        byte[] bytes = byteArray.toByteArray();
        StringBuffer buffer = new StringBuffer();
        for (int i = 0; i < bytes.length; i++) {
            int a = bytes[i] & 0xFF;
            if (a < ' ' || a > '~' || a == S || a == E) {
                buffer.append(S);
                buffer.append(toHexString(bytes[i]));
                buffer.append(E);
            } else {
                buffer.append((char)a);
            }
        }
        return buffer.toString();
    }

    /**
     * 񉻂ꂽ񂩂IuWFNg𕜌B
     * @param string 񉻂ꂽ
     * @return ꂽIuWFNg
     */
	public static Object deserialize(String string)  {
		Object obj = null;
        try {
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            try {
                for (int i = 0, n = string.length(); i < n; i++) {
                    char c = (char)string.charAt(i);
                    if (c == S) {
                        String hex = string.substring(i + 1, i + 3);
                        os.write(Integer.parseInt(hex, 16));
                        i += 3;
                    } else {
                        os.write(c);
                    }
                }
            } finally {
                os.close();
            }
            ObjectInputStream is = new ObjectInputStream(new ByteArrayInputStream(os.toByteArray()));
            try {
            	obj = is.readObject();
            } catch (ClassNotFoundException e){
            } finally {
                is.close();
            }
        } catch (IOException ex) {
        }

        return obj;
    }

    /**
     * oCgl16i\LɂB
     * @param b oCgl
     * @return 16i\L
     */
    private static String toHexString(byte b) {
        final String chars = "0123456789ABCDEF";
        int lo = b & 0xF;
        int hi = b >> 4 & 0xF;
        return new String(new char[]{chars.charAt(hi), chars.charAt(lo)});
    }

	public static byte[]   encrypt(String key, String text)
		throws javax.crypto.IllegalBlockSizeException,
			java.security.InvalidKeyException,
			java.security.NoSuchAlgorithmException,
			java.io.UnsupportedEncodingException,
			javax.crypto.BadPaddingException,
			javax.crypto.NoSuchPaddingException {
		javax.crypto.spec.SecretKeySpec sksSpec = 
		    new javax.crypto.spec.SecretKeySpec(key.getBytes(), "Blowfish");
		javax.crypto.Cipher cipher = 
		    javax.crypto.Cipher.getInstance("Blowfish");
		cipher.init(javax.crypto.Cipher.ENCRYPT_MODE, sksSpec);
		byte[] encrypted = cipher.doFinal(text.getBytes());
		return encrypted;
	}

	public static String   decrypt(String key, byte[] encrypted)
    throws javax.crypto.IllegalBlockSizeException,
        java.security.InvalidKeyException,
        java.security.NoSuchAlgorithmException,
        java.io.UnsupportedEncodingException,
        javax.crypto.BadPaddingException,
        javax.crypto.NoSuchPaddingException {
		javax.crypto.spec.SecretKeySpec sksSpec = 
		    new javax.crypto.spec.SecretKeySpec(key.getBytes(), "Blowfish");
		javax.crypto.Cipher cipher = 
		    javax.crypto.Cipher.getInstance("Blowfish");
		cipher.init(javax.crypto.Cipher.DECRYPT_MODE, sksSpec);
		byte[] decrypted = cipher.doFinal(encrypted);
		return new String(decrypted);
	}
}